package diploma;
import java.awt.*;

public class Node extends Object{
  int X;
  int Y;
  int Mod;   //zaporny == koncovy stav
  int Id;
  int Color;  // 0..BLACK(normal),  1..RED(finite),  2..GREEN(vhodny naslednik v jednom kroku),
              // 3..BLUE(konecna cesta),  4..YELLOW(aktualni)
  int Index;
  int Level;
  int Sublevel;
  String Name;
  EdgeListItem FirstEdgeIn;
  EdgeListItem FirstEdgeOut;
  Node NextNode;

  //empty constructor
  Node() {
    X=0;
    Y=0;
    Mod=0;
    Id=0;
    Color=0;
    Index=0;
    Level=0;
    Sublevel=0;
    Name="";
    FirstEdgeIn=null;
    FirstEdgeOut=null;
    NextNode=null;
  }

  //constructor without in/out edges references
  Node(int init_x, int init_y, int init_mod, int init_id, int init_color, int init_index, int init_level, int init_sublevel, String init_name) {
    X=init_x;
    Y=init_y;
    Mod=init_mod;
    Id=init_id;
    Color=init_color;
    Index=init_index;
    Level=init_level;
    Sublevel=init_sublevel;
    Name=init_name;
    FirstEdgeIn=null;
    FirstEdgeOut=null;
    NextNode=null;
  }

  //full constructor
  Node(int init_x, int init_y, int init_mod, int init_id, int init_color, int init_index, int init_level, int init_sublevel, String init_name, EdgeListItem init_inref, EdgeListItem init_outref, Node init_nextnode ) {
    X=init_x;
    Y=init_y;
    Mod=init_mod;
    Id=init_id;
    Color=init_color;
    Index=init_index;
    Level=init_level;
    Sublevel=init_sublevel;
    Name=init_name;
    FirstEdgeIn=init_inref;
    FirstEdgeOut=init_outref;
    NextNode=init_nextnode;
  }

  //accessors
  public int GetX() { return X; }
  public int GetY() { return Y; }
  public int GetMod() { return Mod; }
  public int GetId() { return Id; }
  public int GetColor() { return Color; }
  public int GetIndex() { return Index; }
  public int GetLevel() { return Level; }
  public int GetSublevel() { return Sublevel; }
  public String GetName() { return Name; }
  public EdgeListItem GetFirstEdgeIn() { return FirstEdgeIn; }
  public EdgeListItem GetFirstEdgeOut() { return FirstEdgeOut; }
  public Node GetNextNode() { return NextNode; }

  public int GetNumInEdges(){
        int num=0;
        EdgeListItem eli = FirstEdgeIn;
        while(eli != null){
            num++;
            eli = eli.NextEdge;
        }
        return num;    
  }

  public int GetNumOutEdges(){
        int num=0;
        EdgeListItem eli = FirstEdgeOut;
        while(eli != null){
            num++;
            eli = eli.NextEdge;
        }
        return num;    
  }

  void SetX(int new_x) { X=new_x; }
  void SetY(int new_y) { Y=new_y; }
  void SetMod(int new_mod) { Mod=new_mod; }
  void SetId(int new_id) { Id=new_id; }
  void SetColor(int new_color) { Color=new_color; }
  void SetIndex(int new_index) { Index=new_index; }
  void SetLevel(int new_level) { Level=new_level; }
  void SetSublevel(int new_sublevel) { Sublevel=new_sublevel; }
  void SetName(String new_name) { Name=new_name; }
  void SetFirstEdgeIn(EdgeListItem new_firstedgein) { FirstEdgeIn=new_firstedgein; }
  void SetFirstEdgeOut(EdgeListItem new_firstedgeout) { FirstEdgeOut=new_firstedgeout; }
  void SetNextNode(Node new_nextnode) { NextNode=new_nextnode; }

  // vraci posledni polozku v seznamu vystupnich hran z uzlu
  EdgeListItem FindLastOutEdge() {
    EdgeListItem Temp = FirstEdgeOut;
    if (Temp == null) { return null; }
    else {
      while (Temp.NextEdge != null){
        Temp = Temp.NextEdge;
      }
      return Temp;
    }
  }

  // vraci posledni polozku v seznamu vstupnich hran do uzlu
  EdgeListItem FindLastInEdge() {
    EdgeListItem Temp = FirstEdgeIn;
    if (Temp == null) { return null; }
    else {
      while (Temp.NextEdge != null){
        Temp = Temp.NextEdge;
      }
      return Temp;
    }
  }

}




