package diploma;
import java.lang.*;
import java.util.Vector;


public class Parser extends Object {

  //datove polozky
  String pattern = new String();
  Vector vect = new Vector();
  Vector init_states = new Vector();
  Vector neighbour_set = new Vector();
  Vector finite_states = new Vector();

  //constructors
  Parser() {
    super();
  }

  Parser(String init_pattern) {
    pattern = init_pattern;
  }

  //accessors
  void SetPattern(String new_pattern){
    pattern = new_pattern;
  }

  Vector GetInitStates(){
    return init_states;
  }

  Vector GetNeighbourSet(){
    return neighbour_set;
  }

  Vector GetFiniteStates(){
    return finite_states;
  }

  //**************************************//
  //ze vstupniho vzorku (vektor pattern) napr ve tvaru "+a+b*c" vytvori novy vektor
  //kde jsou jednotlive alfanumericke znaky ocislovany a ostatni znaky jsou chapany jako
  //ridici a jen se prekopiruji. Ziskavame tedy tvar: "+ a1 + b2 * c3"

  void MakeSequence() {
      vect.clear();
      int k=1;   // zapisovany index
      int j=0;
      for(int i=0; i<pattern.length(); i++){
          if(Character.isLetterOrDigit(pattern.charAt(i))) {
              Integer obj_int = new Integer(k++);
              Character obj_char = new Character(pattern.charAt(i));
              vect.addElement((String)(obj_char.toString() + obj_int.toString()) );
          }
          else {
              Character obj_char = new Character(pattern.charAt(i));
              vect.addElement((String) obj_char.toString());
          }
      }
  }


  //**************************************//
  //prochazi postupne vektor naplneny retezci napr. "+ a1 + b2 * c3" a hleda pocatecni stavy
  //jsou to polozky nachazejici se za polozkami "+", v pripade ze nasleduje znak iterace, pak
  //to mohou byt i polozky nasledne. Vysledek je tedy napr. : "a1 b2 c3"

  void MakeInitStates() {
      init_states.clear();
   //   boolean iteration;
   //   int j;
      for(int i=0; i<vect.size(); i++){
          if(vect.elementAt(i).equals("+")){
   //           j=i+1;
   //           init_states.addElement(vect.elementAt(j));
              init_states.addElement(vect.elementAt(i+1).toString());
   //           j++;
      /*
             do{
                  iteration=false;
                  if(vect.size()>j && vect.elementAt(j).equals("*")){
                      j++;
                      if(vect.size()>j && !vect.elementAt(j).equals("+")){
                          init_states.addElement(vect.elementAt(j));
                          j++;
                          iteration = true;
                      }
                  }
              }while(iteration);
      */
          } //end if
      } //end for
  } //end method


  //**************************************//
  void MakeNeighbourSet() {
      neighbour_set.clear();
      //String first, second;

      for(int i=0; i<(vect.size()-1); i++){
          //ani jeden ze znaku nesmi byt "+"
          if(!vect.elementAt(i).equals("+") && !vect.elementAt(i+1).equals("+")){
              //pokud ani jeden ze znaku neni "*", pak se jedna o dva sousedni neridici znaky napr. "a b"
              if(!vect.elementAt(i).equals("*") && !vect.elementAt(i+1).equals("*")){
                  neighbour_set.addElement(vect.elementAt(i).toString() + " " + vect.elementAt(i+1).toString());
              }
              //jinak pokud druhy je "*", pak pridam smycku na predchozi
              else if(vect.elementAt(i+1).equals("*")){
                  neighbour_set.addElement(vect.elementAt(i).toString() + " " + vect.elementAt(i).toString());
              }
              //jinak pokud prvni je "*", pak pridam hranu z predchoziho na nasledujici
              else if(vect.elementAt(i).equals("*")){
                  neighbour_set.addElement(vect.elementAt(i-1).toString() + " " + vect.elementAt(i+1).toString());
              }

          } //end if
      } //end for

   /*   int j=0;
      for(int i=0; i<vect.size(); i++){
          j=i;
          if(!vect.elementAt(j).equals("+") && !vect.elementAt(j).equals("*")){
              first=(String)vect.elementAt(j);
              j++;
              if(j<vect.size() && !vect.elementAt(j).equals("+") && !vect.elementAt(j).equals("*")){
                  second=(String)vect.elementAt(j);
                  neighbour_set.addElement(first + " " + second);
                  j++;
                  if(j<vect.size() && vect.elementAt(j).equals("*")){
                      do{
                          j++;
                          if(j<vect.size() && !vect.elementAt(j).equals("+")){
                              second=(String)vect.elementAt(j);
                              neighbour_set.addElement(first + " " + second);
                          }
                          j++;
                      }while(j<vect.size() && vect.elementAt(j).equals("*"));
                  }
              }
              else if(j<vect.size() && vect.elementAt(j).equals("*")){
                  neighbour_set.addElement(first + " " + first);
                  do{
                      j++;
                      if(j<vect.size() && !vect.elementAt(j).equals("+")){
                          second=(String)vect.elementAt(j);
                          neighbour_set.addElement(first + " " + second);
                          j++;
                      }
                  }while(j<vect.size() && vect.elementAt(j).equals("*"));
              }
          }
      }
   */

  } // end of method

  //**************************************//
  void MakeFiniteStates(){
      finite_states.clear();

//      boolean iteration;
//      int j;
      vect.addElement("+");              //beru znak pred +, proto pridam + i na konec
      for(int i=1; i<vect.size(); i++){  //az od jedne!
          if(vect.elementAt(i).equals("+")){
              if(vect.elementAt(i-1).equals("*")){
                  finite_states.addElement(vect.elementAt(i-2).toString());
              }
              else{
                  finite_states.addElement(vect.elementAt(i-1).toString());
              }
 //             j=i-1;
 /*             if(!vect.elementAt(j).equals("*")){
                  finite_states.addElement(vect.elementAt(j));
              }
              else
              do {
                  iteration = false;
                  if(vect.elementAt(j).equals("*")){
                      iteration = true;
                      j--;
                      finite_states.addElement(vect.elementAt(j));
                      j--;
                  }
              } while(iteration);
*/
          } //end if
      } //end for
      vect.removeElementAt(vect.size()-1);  //uvedeni do puvodniho stavu, odebrani ridiciho znaku "+"


  } //end of method



  //**************************************//
  int GetTypeOfPattern(){
      int unions=0;
      int iterations=0;
      for(int i=0; i<pattern.length(); i++){
         if (pattern.charAt(i)=='+') {unions++;}
         if (pattern.charAt(i)=='*') {iterations++;}
      }
      if(iterations>0) {return 2;}
      else if(unions>1) {return 1;}
      else return 0;
  }


} // end of class Parser
